summaryrefslogtreecommitdiffstats
path: root/rfc.sh
diff options
context:
space:
mode:
authorAnand Avati <avati@gluster.com>2011-07-18 16:09:58 +0530
committerAnand Avati <avati@gluster.com>2011-07-18 16:09:58 +0530
commit4c31a8662570a60260b36938d7f67d114befef4e (patch)
tree1408e6cf90bf379ade5f0fef1a443d564bb1c2f3 /rfc.sh
parentb53d76e392f0b88a7d135f099fe52ae933050719 (diff)
s/Patchwork/Gerrit/
Change-Id: I228295f1c33e2c4d991ef6810e2332c3299ca2b7
Diffstat (limited to 'rfc.sh')
-rwxr-xr-xrfc.sh104
1 files changed, 104 insertions, 0 deletions
diff --git a/rfc.sh b/rfc.sh
new file mode 100755
index 00000000000..1439c2f43b0
--- /dev/null
+++ b/rfc.sh
@@ -0,0 +1,104 @@
+#!/bin/bash -e
+
+
+branch="release-3.1";
+
+
+function set_hooks_commit_msg()
+{
+ f=".git/hooks/commit-msg";
+ u="http://review.gluster.com/tools/hooks/commit-msg";
+
+ if [ -x "$f" ]; then
+ return;
+ fi
+
+ curl -o $f $u || wget -O $f $u;
+
+ chmod +x .git/hooks/commit-msg;
+}
+
+
+function is_num()
+{
+ local num;
+
+ num="$1";
+
+ [ -z "$(echo $num | sed -e 's/[0-9]//g')" ]
+}
+
+
+function rebase_changes()
+{
+ git fetch --all;
+
+ EDITOR=$0 git rebase -i origin/$branch;
+}
+
+
+function editor_mode()
+{
+ if [ $(basename "$1") = "git-rebase-todo" ]; then
+ sed -i 's/^pick /reword /g' "$1";
+ return;
+ fi
+
+ if [ $(basename "$1") = "COMMIT_EDITMSG" ]; then
+ if grep -qi '^BUG: ' $1; then
+ return;
+ fi
+ while true; do
+ echo Commit: "\"$(head -n 1 $1)\""
+ echo -n "Enter Bug ID: "
+ read bug
+ if [ -z "$bug" ]; then
+ return;
+ fi
+ if ! is_num "$bug"; then
+ echo "Invalid Bug ID ($bug)!!!";
+ continue;
+ fi
+
+ sed -i "s/^\(Change-Id: .*\)$/\1\nBUG: $bug/g" $1;
+ return;
+ done
+ fi
+
+ cat <<EOF
+$0 - editor_mode called on unrecognized file $1 with content:
+$(cat $1)
+EOF
+ return 1;
+}
+
+
+function assert_diverge()
+{
+ git diff origin/$branch..HEAD | grep -q .;
+}
+
+
+function main()
+{
+ if [ -e "$1" ]; then
+ editor_mode "$@";
+ return;
+ fi
+
+ set_hooks_commit_msg;
+
+ rebase_changes;
+
+ assert_diverge;
+
+ bug=$(git show --format='%b' | grep -i '^BUG: ' | awk '{print $2}');
+
+ if [ -z "$bug" ]; then
+ git push origin HEAD:refs/for/$branch/rfc;
+ else
+ git push origin HEAD:refs/for/$branch/bug-$bug;
+ fi
+}
+
+main "$@"